
/*  -*- MaTX -*-
 *
 *  yOz
 *      corrcoef_col() - ֌W(񖈂̃f[^)
 *
 *  y`z
 *      C = corrcoef_col(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = corrcoef_col(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  y@\z
 *      X xNĝƂCcorrcoef_col(X) X ̐̑֌W 1 ԂB
 *      X ŝƂCcorrcoef_col(X) ́CX ̗񖈂Ƀf[^ۑ
 *      ƌȂC֌W߂B
 *
 *      corrcoef_col(X,Y) ́CX  Y ̃xNgȂC
 *      corrcoef_col([makecolv(X) makecolv(Y)])ƓłB
 *
 *  yz
 *      >> C = corrcoef_col([1 2 3 4 5])
 *      === [C] : (  1,  1) ===
 *                (  1)     
 *      (  1)  1.00000000E+00
 *
 *      >> C = corrcoef_col([2 3 1 4 5], [10 9 7 8 6])
 *      === [C] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  1.41421355E+00 -5.65685428E-01
 *      (  2) -5.65685428E-01  1.41421355E+00
 *
 *  y֘Aځz
 *      sum, median, mean, corrcoef_row
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      corrcoef_row() - ֌W(s̃f[^)
 *
 *  y`z
 *      C = corrcoef_row(X)
 *         Matrix C;
 *         Matrix X;
 *
 *      C = corrcoef_row(X,Y)
 *         Matrix C;
 *         Matrix X,Y;
 *
 *  y@\z
 *      X xNĝƂCcorrcoef_row(X) X ̐̑֌W 1 ԂB
 *      X ŝƂCcorrcoef_row(X) ́CX ̍sɃf[^ۑ
 *      ƌȂC֌W߂B
 *
 *      corrcoef_row(X,Y) ́CX  Y ̃xNgȂC
 *      corrcoef_row([[makerowv(X)][makerowv(Y)]])ƓłB
 *
 *  yz
 *      >> C = corrcoef_row([1 2 3 4 5])
 *      === [C] : (  1,  1) ===
 *                (  1)     
 *      (  1)  1.00000000E+00
 *
 *      >> C = corrcoef_row([2 3 1 4 5], [10 9 7 8 6])
 *      === [C] : (  2,  2) ===
 *                 (  1)           (  2)     
 *      (  1)  1.41421355E+00 -5.65685428E-01
 *      (  2) -5.65685428E-01  1.41421355E+00
 *
 *  y֘Aځz
 *      sum, median, mean, corrcoef_col
 */


Func Array corrcoef_col(x, y, ...)
	Array x, y;
{
	Array cc;
	Matrix dv, cv;

	error(nargchk(1, 2, nargs, "corrcoef_col"));

	if (nargs == 1) {
		cv = cov_col(x);
	} else if (nargs == 2) {
		cv = cov_col(x, y);
	}

	dv = diag_vec(cv);
	cc = Array(cv) / sqrt(Array(dv*dv#));
	return cc;
}

Func Array corrcoef_row(x, y, ...)
	Array x, y;
{
	error(nargchk(1, 2, nargs, "corrcoef_row"));
	
	if (nargs == 1) {
		return trans(corrcoef_col(trans(x)));
	} else {
		return trans(corrcoef_col(trans(x), trans(y)));
	}
}



