
/*  -*- MaTX -*-
 *
 *  yOz
 *      logspace() - ΐԊuxNg
 *
 *  y`z
 *      y = logspace(x1, x2, n, ...)
 *         Array y;
 *         Real x1, x2;
 *         ...
 *         Integer n = 100;
 *
 *  y@\z
 *      logspace(x1,x2) ́C10^x1  10^x2 ΐԊu 50  50 
 *      ̒lȂsxNgԂBCx2  PI ȂC10^x1  PI 
 *      ΐԊuB
 *      logspace(x1,x2,N) ́C10^x1  10^x2 ΐԊu N  N 
 *      lȂsxNgԂB
 *
 *  y֘Aځz
 *      linspace
 */

Func Array logspace(x1, x2, n, ...)
	Real x1, x2;
	Integer n;
{
	Array y;

	error(nargchk(2, 3, nargs, "logspace"));

	if (nargs == 2) {
		n = 50;
	}
	if (x2 == PI) {
		x2 = log10(PI);
	}
	if (0 < x1 && 0 < x2 && (abs(x1) <= 0.1 || 10.0 <= abs(x2))) {
		x1 = log10(x1);
		x2 = log10(x2);
	}

	y = 10.0 .^ [x1 .+ [0:n-2]*(x2-x1)/(n-1), x2];
	return y;
}
