
/*  -*- MaTX -*-
 *
 *  yOz
 *      unwrap() - ʑp̏C
 *
 *  y`z
 *      Y = unwrap(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  y@\z
 *      Y = unwrap(X) ́CΒl̕ω PI 傫ƂCʑA
 *      邽߁C+- 2 PI ̐{čs X ̐CBX 
 *      ́CECォ牺ցCQƂBY = unwrap(X, cutoff)
 *      ́CΒl̈ʑ̕ω cuffoff 傫ƂCCB
 *      cutoff ͓xŎw肷B
 *
 *      unwrap() ͕֗ł邪Cf[^Ȃꍇf[^}ɕω
 *      ꍇ͐ʂȂƂB
 * 
 *  yz
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = 1/(s^3 + 2*s^2 + 3*s + 4);
 *      >> data = eval(G, j*w);
 *      >> p = unwrap(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p);
 *
 *  y֘Aځz
 *      unwrap_row, unwrap_col
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      unwrap_col() - 񖈂̈ʑp̏C
 *
 *  y`z
 *      Y = unwrap_col(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap_col(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  y@\z
 *      Y = unwrap_col(X) ́CΒl̕ω PI 傫ƂCʑA
 *      邽߁C+- 2 PI ̐{ăxNg X ̐CB
 *      Y = unwrap_col(X, cutoff)́CΒl̈ʑ̕ω cuffoff 
 *      ƂCCBcutoff ͓xŎw肷B
 *
 *      X ŝƂC񖈂ɈʑpCBY  X Ɠ傫ɂȂB
 *
 *      unwrap_col() ͕֗ł邪Cf[^Ȃꍇf[^}ɕω
 *      ꍇ͐ʂȂƂB
 * 
 *  yz
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = [1/(s^3 + 2*s^2 + 3*s + 4), 1/(s+1)];
 *      >> data = eval(G, j*w');
 *      >> p = unwrap_col(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p');
 *
 *  y֘Aځz
 *      unwrap, unwrap_row
 *
 *   ------------------------------------------------------------------------
 *
 *  yOz
 *      unwrap_row() - s̈ʑp̏C
 *
 *  y`z
 *      Y = unwrap_row(X)
 *         Array Y;
 *         Array X;
 *
 *      Y = unwrap_row(X,cutoff)
 *         Array Y;
 *         Array X;
 *         Real cutoff;
 *
 *  y@\z
 *      Y = unwrap_row(X) ́CΒl̕ω PI 傫ƂCʑA
 *      邽߁C+- 2 PI ̐{ăxNg X ̐CB
 *      Y = unwrap_row(X, cutoff)́CΒl̈ʑ̕ω cuffoff 
 *      ƂCCBcutoff ͓xŎw肷B
 *
 *      X ŝƂCsɈʑpCBY  X Ɠ傫ɂȂB
 *
 *      unwrap_row() ͕֗ł邪Cf[^Ȃꍇf[^}ɕω
 *      ꍇ͐ʂȂƂB
 * 
 *  yz
 *
 *      >> j = (0,1);
 *      >> s = Polynomial("s");
 *      >> w = logspace(-2.0, 3.0);
 *      >> G = [[1/(s^3 + 2*s^2 + 3*s + 4)][1/(s+1)]];
 *      >> data = eval(G, j*w);
 *      >> p = unwrap_row(Im(log(data)));
 *      >> mgplot_semilogx(1,w,p);
 *
 *  y֘Aځz
 *      unwrap, unwrap_col
 */


Func Array unwrap(ph, tol, ...)
	Array ph;
	Real tol;
{
	Array x;
	Integer m, n;

	error(nargchk(1, 2, nargs, "unwrap"));

	m = Rows(ph);
	n = Cols(ph);
	
	if (nargs == 1) {
		if (m == 1 || n == 1) {
			return unwrap_col(ph);
		} else {
			x = unwrap_col(reshape(ph, m*n, 1));
			return reshape(x, m, n);
		}
	} else {
		if (m == 1 || n == 1) {
			return unwrap_col(ph, tol);
		} else {
			x = unwrap_col(reshape(ph, m*n, 1), tol);
			return reshape(x, m, n);
		}
	}
}

Func Array unwrap_row(ph, tol, ...)
	Array ph;
	Real tol;
{
	error(nargchk(1, 2, nargs, "unwrap_row"));
	
	if (nargs == 1) {
		return trans(unwrap_col(trans(ph)));
	} else {
		return trans(unwrap_col(trans(ph), tol));

	}
}

Func Array unwrap_col(ph_, tol, ...)
	Array ph_;
	Real tol;
{
	Integer i,j,k,m,mo,no,n;
	Array ph,ph2,p,pd;
	Index idx;

	error(nargchk(1, 2, nargs, "unwrap_col"));

	if (nargs == 1) {
		tol = PI*170./180.;    // e덷
	}

	ph = ph_;

	{m,n} = size(ph);
	mo = m;
	no = n;
	if (mo < no) {
		ph = trans(ph);
		{m,n} = size(ph);
	}

	ph2 = ph;

	for (j = 1; j <= n; j++) {
		p = ph(:,j);
		pd = diff(p);
		idx = find(abs(pd) > tol);
		for (i = 1; i <= length(idx); i++) {
			k = idx(i);
			p(k+1:m) = p(k+1:m) .- 2*PI*sgn(pd(k));
		}
		ph2(:,j) = p;
	}

	if (mo < no) {
		ph2 = trans(ph2);
	}
	return ph2;
}
