
/*  -*- MaTX -*-
 *
 *  yOz
 *      Ode45Auto() - RKF45@(ݒ)ŏ
 *
 *  y`z
 *      {T,X} = Ode45Auto(t0,t1,x0,diff_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin;
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,
 *                                                         dtmin,dtmax)
 *         Array T,X,U;
 *         Real t0,t1;
 *         Matrix x0;
 *         Matrix diff_eqs(t,x,u); (Real t; Matrix x,u;)
 *         Matrix link_eqs(t,x);   (Real t; Matrix x;)
 *         Real eps,dtsav,dtmin,dtmax;
 *
 *  y@\z
 *      {T,X} = Ode45Auto(t0,t1,x0,diff_eqs)́C֐diff_eqs()Œ`
 *       RKF45@gCeɂ덷 eps = 1.0E-6 
 *      ȉɂȂ悤ݕ߂ȂCԂ̎n X ƎԂ
 *      n T ԂB 
 *
 *      ݕ̍ŏĺCdtmin = EPSCől dtmax = abs(t1-t0)/5C
 *      f[^ۑ̍ŏԊúCdtsav = 1.0E-3 łBݕ dtmin 
 *      ĂC덷 eps ȉɂȂȂꍇCxbZ[W\C
 *      ̎֐iށB
 *
 *      {T,X,U} = Ode45Auto(t0,t1,x0,diff_eqs,link_eqs)́Clink_eqs()
 *      ̌vZʂOM u ƂāC֐ diff_eqs() ɓnȂC
 *      CԂ̎n XCOM̎n UCԂ̌n T 
 *      ԂB
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps)́Ceɂ
 *      덷 eps ɂȂ悤ݕ𒲐߂ȂB
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav)́Cۑf[^
 *      ̊Ԋu dtsav ȏɂCf[^ԈB
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin)́Cݕ
 *      ŏl dtmin ɂB
 *
 *      Ode45Auto(t0,t1,x0,diff_eqs,link_eqs,eps,dtsav,dtmin,dtmax)́C
 *      ݕ̍ől dtmax ɂB
 *
 *      ̈ӖɎB
 *
 *          t0              : 
 *          t1              : I[
 *          x0              : 
 *          diff_eqs(t,x,u) :  tC xCOM u 
 *                          : Ԃ̔vZ
 *          link_eqs(t,x)   :  tC x OMvZ
 *          eps             : ȇł؂덷̍ől
 *          dtsave          : f[^ۑ̍ŏԊu
 *          dtmin           : ݕ̍ŏl
 *          dtmax           : ݕ̍ől
 *
 *  yz
 *      [U[Y}jAQƁB
 *
 *  y֘Aځz
 *      rkf45(), Ode45(), Ode45Hybrid(), Ode45HybridAuto()
 */
