
/*  -*- MaTX -*-
 *
 *  yOz
 *      integral() - ϕ(sϕ)
 *
 *  y`z
 *      y = integral(x)
 *         (Integer|Real|Complex|Polynomial) y;
 *         (Integer|Real|Complex|Polynomial) x;
 *
 *      y = integral(x,k)
 *         (Integer|Real|Complex|Polynomial) y;
 *         (Integer|Real|Complex|Polynomial) x;
 *         Integer k;
 *
 *      Y = integral(X)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *
 *      Y = integral(X,k)
 *         (Matrix|Array) Y;
 *         (Matrix|Array) X;
 *         Integer k;
 *
 *  y@\z
 *      (||f|) x ɂāCintegral(x) x ̕sϕ
 *      ߂Bintegral(x,k)  k K̕sϕ߂B
 *
 *	    X (s|z)̂ƂCX ̊e integral(X(i,j)) p
 *      ʂȂ(s|z)߂BY ̑傫 X ̑傫ƓɂȂB
 *      integral(X,k)  k K̕sϕ߂B
 *
 *  yz
 *      >> y = integral(3.14)
 *      y = 3.14 s
 *      >> y = integral((3.14, 2.6))
 *      y = (3.14, 2.6) s
 *      >> s = Polynomial("s");
 *      >> y = integral((1,3)*s + (2,4))
 *      y = (0.5,1.5) s^2 + (2,4) s
 *      >> Y = integral([2*s+1, 2])
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)          s^2 + s                         2 s            
 *      >> Y = integral([2*s+1, 2], 2)
 *      === [Y] : (  1,  2) ===
 *           [          (  1)           ]  [          (  2)           ]
 *      (  1)   0.333333 s^3 + 0.5 s^2                 s^2            
 *
 *  y֘Aځz
 *      derivative()
 */
